import {
	MinecraftEnchantmentTypes,
	InventoryComponentContainer,
	EnchantmentList,
	EntityQueryOptions,
	BlockLocation,
	ItemStack,
	Items,
	Location,
	Entity,
	world,
	MinecraftBlockTypes,
	Player,
	system,
	BeforeItemUseEvent,
	BlockRaycastOptions,
	BlockPermutation,
	ScoreboardIdentity,
	EntityAgeableComponent,
	BeforeItemUseOnEvent,
	ChatEvent,
	TicksPerSecond,
	EntityMovementSkipComponent
} from "@minecraft/server";
import {
	ActionFormData,
	MessageFormData,
	ModalFormData
} from "@minecraft/server-ui";

const wikitag = 'Wiki'
const commandPrefix = "+"

function tellraw(selector, text) {
	if (selector == undefined) {
		tellraw("@a", "§cPas de sélecteurs !");
	}
	else if (!selector.match(/@/g)) {
		runCommandAsync(`tellraw "${selector}" {"rawtext":[{"text":"§r${text.replace(/"/g, "\'")}"}]}`);
	}
	else {
		runCommandAsync(`tellraw ${selector} {"rawtext":[{"text":"§r${text.replace(/"/g, "\'")}"}]}`);
	}
}

function runCommandAsync(command) {
	try {
		return { error: false, ...world.getDimension(`overworld`).runCommandAsync(command) };
	} catch (error) {
		return { error: true };
	}
}

function setTickTimeout(callback, tick) {                                       //permet de gèrer les délais de ticks
	let ticks = 0
	let TickCallBack = world.events.tick.subscribe(() => {
		ticks += 1
		if (ticks == tick) {
			callback()
			world.events.tick.unsubscribe(TickCallBack)
		}
	})
}

world.events.beforeChat.subscribe(data => {
    let player = data.sender
	if (data.message.startsWith(commandPrefix)) {
        const args = data.message.slice(commandPrefix.length).split(/\s+/g)
		data.cancel = true
		try {
            if (args[0] == "wiki") {
                tellraw(`${player.name}`, "§8[§9Lunar Script§8] §7>> §aClose your chat for see the Wiki ! It will open in 2 seconds")
                runCommandAsync(`playsound note.bass "${player.name}"`)
				setTickTimeout(() => {
					tellraw(`${player.name}`, "§8[§9Lunar Script§8] §7>> §7Authors §f: §9PF KiLLeRZz#8328 §8/ §7Texturing §f: §9! XerFox#8871")
				}, 20)
                setTickTimeout(() => {
                    wiki(player)
				 },30)
            }
          }  catch (error) {
                log(`${error} : ${error.stack}`);
            }
        }
    })

    function log(text) { runCommandAsync(`tellraw @a[tag=log] {"rawtext":[{"text":"§7{log} §r${text.replace(/"/g, "\'")}"}]}`) }

    log("§8[§9Lunar Script§8] §7>> §aRun with succes !")

    function wiki(player) {
        let form = new ActionFormData()
        .title("§9Lunar Wiki")
        .body("§9§l>> §r§7Choose the category !")
        .button("§8[§9Ores§8]")
		.button("§8[§9Pickaxes§8]")
		.button("§8[§9Swords§8]")
		.button("§8[§9Armors§8]")
		.button("§8[§9Hammers§8]")
		.button("§8[§9Apple§8]")
        .show(player).then(r => {
			if (r.selection === 0) {
				ores(player)
			}
			if (r.selection === 1) {
				pickaxe(player)
			}
			if (r.selection === 2) {
				sword(player)
			}
			if (r.selection === 3) {
				armor(player)
			}
			if (r.selection === 4) {
				hammers(player)
			}
			if (r.selection === 5) {
				apple(player)
			}
		})
    }

	function apple(player) {
		let form = new ActionFormData()
	.title("§9Apple")
	.body("")
	.button("§8[§aPeridot Apple§8]")
	.button("§8[§9Nova Apple§8]")
	.button("§8[§8Opal Apple§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridotapple(player)
		}
		if (r.selection === 1) {
			novaapple(player)
		}
		if (r.selection === 2) {
			opalapple(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
	}

	function peridotapple(player) {
		let form = new ActionFormData()
		.title("§8[§aPeridot Apple§8]")
		.body("§aPeridot Apple §7adds you 5 absorption hearts, a resistance effect III and fire resistance III for 60 seconds.")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			apple(player)
		}
		})
	}

	function novaapple(player) {
		let form = new ActionFormData()
		.title("§8[§9Nova Apple§8]")
		.body("§9Nova Apple §7adds you 4 hearts, 5 absorption hearts, a resistance effect III and fire resistance III for 60 seconds.")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			apple(player)
		}
		})
	}

	function opalapple(player) {
		let form = new ActionFormData()
		.title("§8[§8Opal Apple§8]")
		.body("§8Opal Apple §7adds you 6 hearts, 8 absorption hearts, a resistance effect III and fire resistance III for 60 seconds.")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			apple(player)
		}
		})
	}

	function hammers(player) {
		let form = new ActionFormData()
	.title("§9Hammers")
	.body("")
	.button("§8[§aPeridot Hammer§8]")
	.button("§8[§9Nova Hammer§8]")
	.button("§8[§8Opal Hammer§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridothammer(player)
		}
		if (r.selection === 1) {
			novahammer(player)
		}
		if (r.selection === 2) {
			opalhammer(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
	}

	function peridothammer(player) {
		let form = new ActionFormData()
		.title("§8[§aPeridot Hammer§8]")
		.body("§aPeridot Hammer §7has a durability of 250, digs an area of 9 blocks and can't be repairable")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			hammers(player)
		}
		})
	}

	function novahammer(player) {
		let form = new ActionFormData()
		.title("§8[§9Nova Hammer§8]")
		.body("§9Nova Hammer §7has a durability of 500, digs an area of 9 blocks and can't be repairable")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			hammers(player)
		}
		})
	}

	function opalhammer(player) {
		let form = new ActionFormData()
		.title("§8[§8Opal Hammer§8]")
		.body("§8Opal Hammer §7has a durability of 1000, digs an area of 9 blocks and can't be repairable")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			hammers(player)
		}
		})
	}

	function armor(player) {
		let form = new ActionFormData()
	.title("§9Sword")
	.body("")
	.button("§8[§aPeridot Armor§8]")
	.button("§8[§9Nova Armor§8]")
	.button("§8[§8Opal Armor§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridotarmor(player)
		}
		if (r.selection === 1) {
			novaarmor(player)
		}
		if (r.selection === 2) {
			opalarmor(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
	}

	function peridotarmor(player) {
		let form = new ActionFormData()
		.title("§8[§aPeridot Armor§8]")
		.body("§7All §aPeridot Armor §7can be repairable with §aPeridot Ingot§7.\n\n§aPeridot Helmet §f: §7Durability = 410 / Protection = 4\n§aPeridot Chestplate §f: §7Durability = 620 / Protection = 8\n§aPeridot Leggings §f: §7Durability = 510 / Protection = 6\n§aPeridot Boots §f: §7Durability = 550 / Protection = 4")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			armor(player)
		}
		})
	}

	function novaarmor(player) {
		let form = new ActionFormData()
		.title("§8[§9Nova Armor§8]")
		.body("§7All §9Nova Armor §7can be repairable with §9Nova Ingot§7.\n\n§9Nova Helmet §f: §7Durability = 520 / Protection = 5\n§9Nova Chestplate §f: §7Durability = 740 / Protection = 9\n§9Nova Leggings §f: §7Durability = 620 / Protection = 7\n§9Nova Boots §f: §7Durability = 670 / Protection = 5")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			armor(player)
		}
		})
	}

	function opalarmor(player) {
		let form = new ActionFormData()
		.title("§8[§8Opal Armor§8]")
		.body("§7All §8Opal Armor §7can be repairable with §8Opal Ingot§7.\n\n§8Opal Helmet §f: §7Durability = 640 / Protection = 6\n§8Opal Chestplate §f: §7Durability = 860 / Protection = 10\n§8Opal Leggings §f: §7Durability = 740 / Protection = 8\n§8Opal Boots §f: §7Durability = 790 / Protection = 6")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			armor(player)
		}
		})
	}

	function sword(player) {
		let form = new ActionFormData()
	.title("§9Sword")
	.body("")
	.button("§8[§aPeridot Sword§8]")
	.button("§8[§9Nova Sword§8]")
	.button("§8[§8Opal Sword§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridotsword(player)
		}
		if (r.selection === 1) {
			novasword(player)
		}
		if (r.selection === 2) {
			opalsword(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
	}

	function peridotsword(player) {
		let form = new ActionFormData()
		.title("§8[§aPeridot Sword§8]")
		.body("§aPeridot Sword §7has a durability of 2031, inflicted 9 damages and can be repairable with §aPeridot Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			sword(player)
		}
		})
	}

	function novasword(player) {
		let form = new ActionFormData()
		.title("§8[§9Nova Sword§8]")
		.body("§9Nova Sword §7has a durability of 2300, inflicted 10 damages and can be repairable with §9Nova Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			sword(player)
		}
		})
	}

	function opalsword(player) {
		let form = new ActionFormData()
		.title("§8[§8Opal Sword§8]")
		.body("§8Opal Sword §7has a durability of 2600, inflicted 11 damages and can be repairable with §8Opal Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			sword(player)
		}
		})
	}

	function pickaxe(player) {
		let form = new ActionFormData()
	.title("§9Pickaxes")
	.body("")
	.button("§8[§aPeridot Pickaxe§8]")
	.button("§8[§9Nova Pickaxe§8]")
	.button("§8[§8Opal Pickaxe§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridotpickaxe(player)
		}
		if (r.selection === 1) {
			novapickaxe(player)
		}
		if (r.selection === 2) {
			opalpickaxe(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
	}

	function opalpickaxe(player) {
		let form = new ActionFormData()
		.title("§8[§8Opal Pickaxe§8]")
		.body("§8Opal Pickaxe §7has a durability of 3000 blocks, a mining speed of 20 and can be repairable with §8Opal Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			pickaxe(player)
		}
		})
	}

	function novapickaxe(player) {
		let form = new ActionFormData()
		.title("§8[§9Nova Pickaxe§8]")
		.body("§9Nova Pickaxe §7has a durability of 2500 blocks, a mining speed of 15 and can be repairable with §9Nova Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			pickaxe(player)
		}
		})
	}

	function peridotpickaxe(player) {
		let form = new ActionFormData()
		.title("§8[§aPeridot Pickaxe§8]")
		.body("§aPeridot Pickaxe §7has a durability of 2200 blocks, a mining speed of 12 and can be repairable with §aPeridot Ingot")
		.button("§cRetour")
		.show(player).then(r => {
		if (r.selection === 0) {
			pickaxe(player)
		}
		})
	}

function ores(player) {
	let form = new ActionFormData()
	.title("§9Ores")
	.body("")
	.button("§8[§aPeridot Ore§8]")
	.button("§8[§9Nova Ore§8]")
	.button("§8[§8Opal Ore§8]")
	.button("§cRetour")
	.show(player).then(r => {
		if (r.selection === 0) {
			peridotore(player)
		}
		if (r.selection === 1) {
		    novaore(player) 
		}
		if (r.selection === 2) {
			opalore(player)
		}
		if (r.selection === 3) {
			wiki(player)
		}
	})
}

function peridotore(player) {
	let form = new ActionFormData()
	.title("§8[§aPeridot Ore§8]")
	.body("§aPeridot Ore §7can be found between layers 50 and -50\nThe maximum veins are composed of 5 ores")
	.button("§cRetour")
	.show(player).then(r => {
	if (r.selection === 0) {
		ores(player)
	}
	})
}

function novaore(player) {
	let form = new ActionFormData()
	.title("§8[§9Nova Ore§8]")
	.body("§9Nova Ore §7can be found between layers 50 and -50\nThe maximum veins are composed of 4 ores")
	.button("§cRetour")
	.show(player).then(r => {
	if (r.selection === 0) {
		ores(player)
	}
	})
}

function opalore(player) {
	let form = new ActionFormData()
	.title("§8[§8Opal Ore§8]")
	.body("§8Opal Ore §7can be found between layers 50 and -50\nThe maximum veins are composed of 3 ores")
	.button("§cRetour")
	.show(player).then(r => {
	if (r.selection === 0) {
		ores(player)
	}
	})
}